## scifem 0.3.0

=== debian/changelog ===
scifem (0.3.0-2) unstable; urgency=medium

  * debian/tests Depends: python3-all-dev not python3-all, to get
    Python headers needed by cffi (via ffcx) for non-default Python
    versions. Closes: #1096194.

 -- Drew Parsons <dparsons@debian.org>  Mon, 17 Feb 2025 16:54:38 +0100

scifem (0.3.0-1) unstable; urgency=medium

  * Initial release. (Closes: #1092347)
  * debian patch no_rpath.patch switches off adding RPATH to binary
    python extensions
  * debian/py3dist-overrides identifies fenics_dolfinx as python3-dolfinx
  * debian/tests: use ADIOS2_ALWAYS_USE_MPI=1 to distinguish serial
    xdmf (point cloud) tests with h5py and with adios2 (needs MPI even
    for single process). Separately, run all tests under MPI.

 -- Drew Parsons <dparsons@debian.org>  Sat, 11 Jan 2025 15:14:55 +0100

=== debian/tests/control ===
# "serial" test uses h5py instead of adios2 for point clouds (xdmf)
Test-Command: for py in `py3versions -s`; do $py -m pytest; done
Depends: python3-scifem,
	 python3-pytest,
	 python3-all-dev

# test xdmf serial point cloud with adios2 instead of h5py via mpi (as single process)
Test-Command: for py in `py3versions -s`; do ADIOS2_ALWAYS_USE_MPI=1 $py -m pytest -k test_xdmf; done
Depends: python3-scifem,
	 python3-pytest,
	 python3-all-dev

# test MPI
Tests: test-MPI
Depends: python3-scifem,
	 python3-pytest,
	 python3-all-dev

## scifem 0.13.1

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.21)

set(PROJECT_NAME scifem)
# nanobind uses aligned deallocators only present on macOS > 10.14
if(APPLE)
  set(CMAKE_OSX_DEPLOYMENT_TARGET "10.14")
endif()

set(CMAKE_CXX_STANDARD 20)
set(CMAKE_CXX_STANDARD_REQUIRED ON)
set(CMAKE_CXX_EXTENSIONS OFF)
project(${PROJECT_NAME} VERSION "0.1.0.0" LANGUAGES C CXX)

if (WIN32)
    # Windows requires all symbols to be manually exported.
    # This flag exports all symbols automatically, as in Unix.
    set(CMAKE_WINDOWS_EXPORT_ALL_SYMBOLS TRUE)
endif(WIN32)

execute_process(
  COMMAND
    ${Python3_EXECUTABLE} -c
    "import os, sys, basix; sys.stdout.write(os.path.dirname(basix.__file__))"
  OUTPUT_VARIABLE BASIX_PY_DIR
  RESULT_VARIABLE BASIX_PY_COMMAND_RESULT
  ERROR_VARIABLE BASIX_ERROR_OUT
  OUTPUT_STRIP_TRAILING_WHITESPACE
)
find_package(Basix REQUIRED CONFIG HINTS ${BASIX_PY_DIR})

if(Basix_FOUND)
  message(STATUS "Found Basix at ${Basix_DIR}")
endif()

find_package(DOLFINX REQUIRED CONFIG)

if(DOLFINX_FOUND)
  message(STATUS "Found DOLFINx at ${DOLFINX_DIR}")
endif()

find_package(Python COMPONENTS Interpreter Development.Module REQUIRED)

# Detect the installed nanobind package and import it into CMake
execute_process(
  COMMAND "${Python_EXECUTABLE}" -c "import nanobind; print(nanobind.cmake_dir())"
  OUTPUT_STRIP_TRAILING_WHITESPACE OUTPUT_VARIABLE NB_DIR)
list(APPEND CMAKE_PREFIX_PATH "${NB_DIR}")
find_package(nanobind CONFIG REQUIRED)

# We are now ready to compile the actual extension module
nanobind_add_module(
  _scifem
  STABLE_ABI
  src/scifem.cpp
)
target_link_libraries(_scifem PRIVATE dolfinx)

set_target_properties(_scifem PROPERTIES INSTALL_RPATH_USE_LINK_PATH TRUE)

# Install directive for scikit-build-core
install(TARGETS _scifem LIBRARY DESTINATION ${PROJECT_NAME})

## scifem 0.3.1

=== debian/changelog ===
scifem (0.3.1-1) unstable; urgency=medium

  * New upstream release

 -- Drew Parsons <dparsons@debian.org>  Sun, 02 Mar 2025 12:56:01 +0100

scifem (0.3.0-5) unstable; urgency=medium

  * debian/tests MPI test Depends: python3-h5py-mpi.
    Otherwise h5py-serial is used, causing MPI tests to fail.

 -- Drew Parsons <dparsons@debian.org>  Sun, 23 Feb 2025 11:41:59 +0100

scifem (0.3.0-4) unstable; urgency=medium

  * debian/tests: run MPI tests verbose and report number of available
    (and used) processors

 -- Drew Parsons <dparsons@debian.org>  Fri, 21 Feb 2025 14:38:05 +0100

scifem (0.3.0-3) unstable; urgency=medium

  * debian/tests: switch off pytest colour in MPI tests

 -- Drew Parsons <dparsons@debian.org>  Tue, 18 Feb 2025 11:21:47 +0100

=== debian/control ===
Source: scifem
Section: libs
Priority: optional
Maintainer: Drew Parsons <dparsons@debian.org>
Rules-Requires-Root: no
Build-Depends:
 debhelper-compat (= 13),
 dh-sequence-python3,
 pybuild-plugin-pyproject,
 python3-scikit-build-core,
 python3-setuptools,
 python3-all-dev,
 python3-adios2,
 python3-basix,
 python3-dolfinx,
 python3-h5py,
 python3-mpi4py,
 python3-nanobind,
 python3-numpy,
 python3-packaging,
 python3-petsc4py,
 python3-pytest <!nocheck>,
 python3-ufl,
 libspdlog-dev,
 mpi-default-dev
#Testsuite: autopkgtest-pkg-python
Standards-Version: 4.7.0
Homepage: https://scientificcomputing.github.io/scifem/README.html
Vcs-Browser: https://salsa.debian.org/science-team/fenics/scifem
Vcs-Git: https://salsa.debian.org/science-team/fenics/scifem.git

Package: python3-scifem
Architecture: any
Depends:
 python3-adios2,
 python3-basix,
 python3-h5py,
 python3-mpi4py,
 python3-petsc4py,
 python3-ufl,
 ${python3:Depends},
 ${misc:Depends},
 ${shlibs:Depends}
Suggests:
 python-scifem-doc,
Description: Scientific Computing Tools for Finite Element Methods (Python 3)
 This package contains a collection of tools for scientific computing
 with a focus on finite element methods. The tools are written in
 Python and are intended to be used in conjunction with the dolfinx.
 . 
 Many users that are transitioning from legacy FEniCS to FEniCSx may
 find the transition difficult due to the lack of some functionalities
 in FEniCSx. This package aims to provide some of the functionalities
 that are missing in FEniCSx.
 .
 Features:
  -  Real-space implementation for usage in DOLFINx (>=v0.8.0)
  -  Save quadrature functions as point clouds
  -  Save any function that can tabulate dof coordinates as point clouds.
  -  Point sources for usage in DOLFINx
  -  Simplified wrapper to create MeshTags based on a list of tags and
     corresponding locator functions.
  -  Maps between degrees of freedom and vertices: vertex_to_dofmap and
     dof_to_vertex
  -  Blocked Newton Solver
  -  Function evaluation at specified points
 .
 This package installs the library for Python 3.

=== debian/tests/control ===
--- 
+++ 
@@ -14,4 +14,5 @@
 Tests: test-MPI
 Depends: python3-scifem,
 	 python3-pytest,
-	 python3-all-dev
+	 python3-all-dev,
+	 python3-h5py-mpi

## scifem 0.5.0

=== debian/changelog ===
scifem (0.5.0-4) unstable; urgency=medium

  * mpich (on 32-bit systems) sends warning messages to stderr,
    breaking debci tests. Redirect mpich stderr to stdout.

 -- Drew Parsons <dparsons@debian.org>  Fri, 04 Apr 2025 21:20:13 +0200

scifem (0.5.0-3) unstable; urgency=medium

  * Depends:python3-adios2 only on architectures where adios2 is
    available (not 32-bit and not hurd). h5py is used as a fallback.

 -- Drew Parsons <dparsons@debian.org>  Fri, 04 Apr 2025 12:48:58 +0200

scifem (0.5.0-2) unstable; urgency=medium

  * Build-Depends: python3-nibabel. Also for debian/tests.
    python3-scifem Recommends: python3-nibabel.
    nibabel is required by the biomedical submodule, and used by
    test_read_mri_data

 -- Drew Parsons <dparsons@debian.org>  Fri, 04 Apr 2025 11:47:09 +0200

scifem (0.5.0-1) unstable; urgency=medium

  * New upstream release
  * Standards-Version: 4.7.2

 -- Drew Parsons <dparsons@debian.org>  Fri, 04 Apr 2025 11:25:47 +0200

## scifem 0.6.0

=== debian/changelog ===
scifem (0.6.0-3) unstable; urgency=medium

  * debian patch python_depends_nanobind.patch injects nanobind into
    python depends (pyproject.toml) to allow dh_python3 to catch the
    nanobind ABI dependency. See nanobind transition Bug#1111004.

 -- Drew Parsons <dparsons@debian.org>  Fri, 12 Sep 2025 03:31:03 +0200

scifem (0.6.0-2) unstable; urgency=medium

  * update to unstable for inclusion in trixie (unblock Bug#1106702)

 -- Drew Parsons <dparsons@debian.org>  Fri, 30 May 2025 12:57:29 +0200

scifem (0.6.0-1) experimental; urgency=medium

  * New upstream release
    - updates blocked solver API
    - updates read_mri_data_to_function
    - fixes xdmf and adios2 file handling

 -- Drew Parsons <dparsons@debian.org>  Tue, 27 May 2025 12:30:36 +0200

## scifem 0.10.0

=== debian/changelog ===
scifem (0.10.0-1) unstable; urgency=medium

  * New upstream release

 -- Drew Parsons <dparsons@debian.org>  Tue, 23 Sep 2025 12:27:00 +0200

## scifem 0.13.1

=== debian/changelog ===
scifem (0.13.1-1) unstable; urgency=medium

  * New upstream release

 -- Drew Parsons <dparsons@debian.org>  Thu, 16 Oct 2025 14:28:10 +0200

=== debian/control ===
--- 
+++ 
@@ -10,12 +10,13 @@
  python3-scikit-build-core,
  python3-setuptools,
  python3-all-dev,
- python3-adios2,
+ python3-adios2 [!armel !armhf !i386 !hppa !hurd-amd64 !hurd-i386 !m68k !powerpc !sh4 !x32],
  python3-basix,
  python3-dolfinx,
  python3-h5py,
  python3-mpi4py,
  python3-nanobind,
+ python3-nibabel,
  python3-numpy,
  python3-packaging,
  python3-petsc4py,
@@ -24,7 +25,7 @@
  libspdlog-dev,
  mpi-default-dev
 #Testsuite: autopkgtest-pkg-python
-Standards-Version: 4.7.0
+Standards-Version: 4.7.2
 Homepage: https://scientificcomputing.github.io/scifem/README.html
 Vcs-Browser: https://salsa.debian.org/science-team/fenics/scifem
 Vcs-Git: https://salsa.debian.org/science-team/fenics/scifem.git
@@ -32,7 +33,7 @@
 Package: python3-scifem
 Architecture: any
 Depends:
- python3-adios2,
+ python3-adios2 [!armel !armhf !i386 !hppa !hurd-amd64 !hurd-i386 !m68k !powerpc !sh4 !x32],
  python3-basix,
  python3-h5py,
  python3-mpi4py,
@@ -41,6 +42,7 @@
  ${python3:Depends},
  ${misc:Depends},
  ${shlibs:Depends}
+Recommends: python3-nibabel
 Suggests:
  python-scifem-doc,
 Description: Scientific Computing Tools for Finite Element Methods (Python 3)

=== debian/rules ===
#!/usr/bin/make -f

# See debhelper(7) (uncomment to enable).
# Output every command that modifies files on the build system.
#export DH_VERBOSE = 1

export PYBUILD_NAME=scifem

%:
	dh $@ --buildsystem=pybuild

=== debian/tests/control ===
--- 
+++ 
@@ -1,6 +1,7 @@
 # "serial" test uses h5py instead of adios2 for point clouds (xdmf)
 Test-Command: for py in `py3versions -s`; do $py -m pytest; done
 Depends: python3-scifem,
+	 python3-nibabel,
 	 python3-pytest,
 	 python3-all-dev
 
@@ -13,6 +14,8 @@
 # test MPI
 Tests: test-MPI
 Depends: python3-scifem,
+	 python3-nibabel,
 	 python3-pytest,
 	 python3-all-dev,
-	 python3-h5py-mpi
+	 python3-h5py-mpi,
+	 mpi-default-dev

=== debian/watch ===
version=4

opts=\
 filenamemangle=s%.*/@ANY_VERSION@%@PACKAGE@-$1.tar.gz%,\
 downloadurlmangle=s%(api.github.com/repos/[^/]+/[^/]+)/git/refs/%$1/tarball/refs/%g,\
 searchmode=plain \
 https://api.github.com/repos/scientificcomputing/scifem/git/matching-refs/tags/ \
 https://api.github.com/repos/[^/]+/[^/]+/git/refs/tags/@ANY_VERSION@

## scifem 0.14.0

=== CMakeLists.txt ===
--- 
+++ 
@@ -38,7 +38,7 @@
   message(STATUS "Found DOLFINx at ${DOLFINX_DIR}")
 endif()
 
-find_package(Python COMPONENTS Interpreter Development.Module REQUIRED)
+find_package(Python COMPONENTS Interpreter Development.Module ${SKBUILD_SABI_COMPONENT} REQUIRED)
 
 # Detect the installed nanobind package and import it into CMake
 execute_process(
@@ -47,12 +47,30 @@
 list(APPEND CMAKE_PREFIX_PATH "${NB_DIR}")
 find_package(nanobind CONFIG REQUIRED)
 
+
+if(NOT "${SKBUILD_SABI_VERSION}" STREQUAL "")
+  set(NANOBIND_SABI "STABLE_ABI")
+endif()
+
 # We are now ready to compile the actual extension module
 nanobind_add_module(
   _scifem
-  STABLE_ABI
+  ${NANOBIND_SABI}
   src/scifem.cpp
 )
+
+if(NANOBIND_SABI)
+  # mpi4py and petsc4py use generated Cython headers so tell
+  # them that the limited API is in use.
+  target_compile_definitions(_scifem PRIVATE MPI4PY_LIMITED_API=1)
+  # Needing to set CYTHON_COMPILING_IN_LIMITED_API is a bug in
+  # Cython-generated API headers, should become unnecessary with
+  # mpi4py/petsc4py releases published using Cython >= 3.1.4
+  # https://github.com/cython/cython/issues/7108
+  target_compile_definitions(_scifem PRIVATE CYTHON_COMPILING_IN_LIMITED_API=1)
+endif()
+
+
 target_link_libraries(_scifem PRIVATE dolfinx)
 
 set_target_properties(_scifem PROPERTIES INSTALL_RPATH_USE_LINK_PATH TRUE)

=== debian/changelog ===
scifem (0.14.0-1exp1) experimental; urgency=medium

  * New upstream release

 -- Drew Parsons <dparsons@debian.org>  Thu, 13 Nov 2025 12:46:51 +0100

## scifem 0.16.1

=== debian/changelog ===
scifem (0.16.1-1build3) resolute; urgency=medium

  * No-change rebuild for python3-nanobind-abi18.

 -- Sudip Mukherjee <sudipm.mukherjee@gmail.com>  Sat, 21 Feb 2026 13:04:22 +0000

scifem (0.16.1-1build2) resolute; urgency=medium

  * No-change rebuild for python3-nanobind-abi17.

 -- Sudip Mukherjee <sudipm.mukherjee@gmail.com>  Sun, 01 Feb 2026 21:15:34 +0000

scifem (0.16.1-1build1) resolute; urgency=medium

  * No-change rebuild for libdolfinx-real0.10.

 -- Sudip Mukherjee <sudipm.mukherjee@gmail.com>  Thu, 01 Jan 2026 19:40:54 +0000

scifem (0.16.1-1) unstable; urgency=medium

  * New upstream release

 -- Drew Parsons <dparsons@debian.org>  Mon, 22 Dec 2025 10:19:33 +0100
